(*********************************************************************)
(*  AMX Corporation                                                  *)
(*  Copyright (c) 2004-2006 AMX Corporation. All rights reserved.    *)
(*********************************************************************)
(* Copyright Notice :                                                *)
(* Copyright, AMX, Inc., 2004-2007                                   *)
(*    Private, proprietary information, the sole property of AMX.    *)
(*    The contents, ideas, and concepts expressed herein are not to  *)
(*    be disclosed except within the confines of a confidential      *)
(*    relationship and only then on a need to know basis.            *)
(*********************************************************************)
PROGRAM_NAME='Elium_DVB_Basic'


(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

dvDVB		= 5001:1:0
//dvDVB		= 0:5:0
vdvDvb	= 41001:1:0

dvTP 		= 10001:1:0

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
// Control of DVB
VOLATILE INTEGER nBtn_DVB[] = 
{
  // 
	9, 	 	// Power Toggle
	10,		// Digit 0
	11,		// Digit 1
	12,		// Digit 2 
	13,		// Digit 3
	14,		// Digit 4
	15,		// Digit 5
	16,		// Digit 6
	17,		// Digit 7
	18,		// Digit 8
	19,		// Digit 9
	21,		// Enter
	22,		// Increment station
	23,		// Decrement Station
	24,		// Volume up
	25,	 	// Volume Down
	26,		// Mute toggle
	45,		// Menu Cursor Up
	46,		// Menu Cursor Down
	47,		// Menu Cursor Left
	48,		// Menu Cursor Right
	49,		// Select Menu Item
	50,		// Exit
	101,	// Info
	105,	// Guide
	235,	// Previous Station
	301,	// Band TV
	302,	// Band Radio
	251,	// Device Online
	252		// Device Initialized
}

VOLATILE INTEGER nTxt_DVB[] =
{
	401,	// Current Station Name
	402,	// Version
	403,	// FW_Version
	404,	// Serial Number
	405,	// Device Model
	406,	// Device Make
	407,	// IP Address
	408		// IP Port
}

VOLATILE INTEGER nLvl_DVB[] =
{
	1			// Volume
}

(***********************************************************)
(*                MODULE DEFINITIONS GO BELOW              *)
(***********************************************************)
// Define your communications module here like so:
DEFINE_MODULE 'Elium_HCR_Comm_dr1_0_0' dvb1(vdvDvb, dvDvb)

// This is a sample UI module and always needs adjustment to your project
// It is not needed to get the module running
DEFINE_MODULE 'Elium_DVB_Sample_UI' dvb_ui1(vdvDVB, dvTP, nBtn_DVB, nTxt_DVB, nLvl_DVB)

(***********************************************************)
(*                  THE EVENTS GO BELOW                    *)
(***********************************************************)
DEFINE_EVENT
// Initialize our module, you need to do this once per comm module
DATA_EVENT[vdvDvb]
{
	ONLINE:
	{
		// Set Properties as needed
		SEND_COMMAND vdvDvb,'PROPERTY-Poll_Time,40'
		
		// IP connection, if we use it
		SEND_COMMAND vdvDvb,'PROPERTY-IP_Address,192.168.66.110'
		SEND_COMMAND vdvDvb,'PROPERTY-IP_Port,4001'
		
		// At last REINIT
		SEND_COMMAND vdvDvb,'REINIT'
	}
}


(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM
