(*********************************************************************)
(*  AMX Corporation                                                  *)
(*  Copyright (c) 2004-2006 AMX Corporation. All rights reserved.    *)
(*********************************************************************)
(* Copyright Notice :                                                *)
(* Copyright, AMX, Inc., 2004-2007                                   *)
(*    Private, proprietary information, the sole property of AMX.    *)
(*    The contents, ideas, and concepts expressed herein are not to  *)
(*    be disclosed except within the confines of a confidential      *)
(*    relationship and only then on a need to know basis.            *)
(*********************************************************************)
MODULE_NAME='Elium_DVB_Sample_UI' (DEV vdvDVB, DEV dvTP, INTEGER nBtn_DVB[], INTEGER nTxt_DVB[], INTEGER nLvl_DVB[])

#INCLUDE 'SNAPI.AXI'

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT
// Some constants to make the UI more readable
bandTV 		= 1
bandRadio = 2

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE INTEGER nCurrent_Volume = 0
VOLATILE INTEGER nCurrent_Band = 0
// {{NSX_DEFINE_VARIABLE
// }}NSX_DEFINE_VARIABLE

DEFINE_FUNCTION updateValues()
{
	SEND_COMMAND vdvDVB,'?XCH'
	SEND_COMMAND vdvDVB,'?BAND'
	SEND_COMMAND vdvDVB,'?FWVERSION'
	SEND_COMMAND vdvDVB,'?VERSION'
	SEND_COMMAND vdvDVB,'?PROPERTY-Device-Make'
	SEND_COMMAND vdvDVB,'?PROPERTY-Device-Model'
	SEND_COMMAND vdvDVB,'?PROPERTY-Device-Serial'
	SEND_COMMAND vdvDVB,'?PROPERTY-IP_Address'
	SEND_COMMAND vdvDVB,'?PROPERTY-IP_Port'
}

(***********************************************************)
(*                  THE EVENTS GO BELOW                    *)
(***********************************************************)
DEFINE_EVENT

// {{NSX_DEFINE_EVENT
// Control of DVB
BUTTON_EVENT[dvTP,nBtn_DVB]
{
  PUSH:
  {
    STACK_VAR INTEGER nBtnIdx
    nBtnIdx = GET_LAST(nBtn_DVB)
		TO[BUTTON.INPUT]
    SWITCH(nBtnIdx)
    {
      CASE 	1: 	 	// Power Toggle
			{ PULSE[vdvDVB, POWER] }
			CASE 	2:		// Digit 0
			{ PULSE[vdvDVB, DIGIT_0] }
			CASE 	3:		// Digit 1
			{ PULSE[vdvDVB, DIGIT_1] }
			CASE 	4:		// Digit 2 
			{ PULSE[vdvDVB, DIGIT_2] }
			CASE 	5:		// Digit 3
			{ PULSE[vdvDVB, DIGIT_3] }
			CASE 	6:		// Digit 4
			{ PULSE[vdvDVB, DIGIT_4] }
			CASE 	7:		// Digit 5
			{ PULSE[vdvDVB, DIGIT_5] }
			CASE 	8:		// Digit 6
			{ PULSE[vdvDVB, DIGIT_6] }
			CASE 	9:		// Digit 7
			{ PULSE[vdvDVB, DIGIT_7] }
			CASE 	10:		// Digit 8
			{ PULSE[vdvDVB, DIGIT_8] }
			CASE 	11:		// Digit 9
			{ PULSE[vdvDVB, DIGIT_9] }
			CASE 	12:		// Enter
			{ PULSE[vdvDVB, MENU_ENTER] }
			CASE 	13:		// Increment station
			{ PULSE[vdvDVB, CHAN_UP] }
			CASE 	14:		// Decrement Station
			{ PULSE[vdvDVB, CHAN_DN] }
			CASE 	15:		// Volume up
			{ TO[vdvDVB, VOL_UP]  }
			CASE 	16:	 	// Volume Down
			{ TO[vdvDVB, VOL_DN] }
			CASE 	17:		// Mute toggle
			{ PULSE[vdvDVB, VOL_MUTE] }
			CASE 	18:		// Menu Cursor Up
			{ PULSE[vdvDVB, MENU_UP] }
			CASE 	19:		// Menu Cursor Down
			{ PULSE[vdvDVB, MENU_DN] }
			CASE 	20:		// Menu Cursor Left
			{ PULSE[vdvDVB, MENU_LT] }
			CASE 	21:		// Menu Cursor Right
			{ PULSE[vdvDVB, MENU_RT] }
			CASE 	22:		// Select Menu Item
			{ PULSE[vdvDVB, MENU_ENTER] }
			CASE 	23:		// Exit
			{ PULSE[vdvDVB, MENU_EXIT] }
			CASE 	24:		// Info
			{ PULSE[vdvDVB, MENU_INFO] }
			CASE 	25:		// Guide
			{ PULSE[vdvDVB, MENU_GUIDE] }
			CASE 	26:		// Previous Station
			{ PULSE[vdvDVB, TUNER_PREV] }
			CASE 	27:		// Band TV
			{ SEND_COMMAND vdvDVB,'BAND-TV' }
			CASE 	28:		// Band Radio
			{ SEND_COMMAND vdvDVB,'BAND-SATELLITE_RADIO' }
			CASE	29:		// Device Online
			CASE	30:		// Device Initialized
			{ SEND_COMMAND vdvDVB,'REINIT' }
    } 
  }
}

LEVEL_EVENT[vdvDVB, VOL_LVL]	// Volume
{
	nCurrent_Volume = LEVEL.VALUE
}

DATA_EVENT[vdvDVB]
{
	ONLINE:
	{
		updateValues()
	}
	COMMAND:
	{
		STACK_VAR CHAR sCmd[50]
		
		sCmd = DuetParseCmdHeader(DATA.TEXT)
		
		SWITCH(sCmd)
		{
			CASE 'BAND' :
			{
				IF (DATA.TEXT == 'TV')
					nCurrent_Band = bandTV
				ELSE IF (DATA.TEXT == 'SATELLITE_RADIO')
					nCurrent_Band = bandRadio
				ELSE
					nCurrent_Band = 0
			}
			CASE 'XCH':
			{
				SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[1]), '-', DATA.TEXT"
			}
			CASE 'VERSION':
			{
				SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[2]), '-', DATA.TEXT"
			}
			CASE 'FWVERSION':
			{
				SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[3]), '-', DATA.TEXT"
			}
			CASE 'PROPERTY':
			{
				sCmd = DuetParseCmdParam(DATA.TEXT)
				SWITCH(sCmd)
				{
					CASE 'Device-Serial':
					{
						SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[4]), '-', DuetParseCmdParam(DATA.TEXT)"
					}
					CASE 'Device-Model':
					{
						SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[5]), '-', DuetParseCmdParam(DATA.TEXT)"
					}
					CASE 'Device-Make':
					{
						SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[6]), '-', DuetParseCmdParam(DATA.TEXT)"
					}
					CASE 'IP_Address':
					{
						SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[7]), '-', DuetParseCmdParam(DATA.TEXT)"
					}
					CASE 'IP_Port':
					{
						SEND_COMMAND dvTP,"'TEXT', ITOA(nTxt_DVB[8]), '-', DuetParseCmdParam(DATA.TEXT)"
					}
				}
			}
		}
	}	// Command
}

DATA_EVENT[dvTP]
{
	ONLINE:
	{
		updateValues()
	}
}

/*
LEVEL_EVENT[dvTP, nLvL_DVB[1]]
{
	LOCAL_VAR INTEGER nLev
	WAIT 3	// We delay this a bit, so we do not flood the device
	{
		SEND_LEVEL vdvDVB, VOL_LVL, nLev
	}
}
*/
CHANNEL_EVENT[vdvDVB, DATA_INITIALIZED]
{
	ON:
	{
		updateValues()
	}
}

// }}NSX_DEFINE_EVENT
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM


// {{NSX_DEFINE_PROGRAM
// Control of DVB
[dvTP,nBtn_DVB[1]] 	= ([vdvDVB, POWER_FB])
[dvTP,nBtn_DVB[17]] = ([vdvDVB, VOL_MUTE_FB])
[dvTP,nBtn_DVB[27]] = (nCurrent_Band == bandTV)
[dvTP,nBtn_DVB[28]] = (nCurrent_Band == bandRadio)
[dvTP,nBtn_DVB[29]] = ([vdvDVB, DEVICE_COMMUNICATING])
[dvTP,nBtn_DVB[30]] = ([vdvDVB, DATA_INITIALIZED])
// }}NSX_DEFINE_PROGRAM

SEND_LEVEL dvTP, nLvl_DVB[1], nCurrent_Volume


